## ensmallen 1.14.3

=== CMakeLists.txt ===
# ensmallen CMake configuration.  This project has no configurable options---it
# just installs the headers to the install location, and optionally builds the
# test program.
cmake_minimum_required(VERSION 2.8.10)
project(ensmallen C CXX)

option(USE_OPENMP "If available, use OpenMP for parallelization." ON)

set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} "${CMAKE_SOURCE_DIR}/CMake")

# Ensure we have C++11 features.  Since we support CMake < 3.1, this needs a
# little bit of special handling.
if ((${CMAKE_MAJOR_VERSION} LESS 3 OR
    (${CMAKE_MAJOR_VERSION} EQUAL 3 AND ${CMAKE_MINOR_VERSION} LESS 1))
    AND NOT FORCE_CXX11)
  # Older versions of CMake do not support target_compile_features(), so we have
  # to use something kind of hacky.
  include(CMake/CXX11.cmake)
  check_for_cxx11_compiler(HAS_CXX11)
  if(NOT HAS_CXX11)
    message(FATAL_ERROR "No C++11 compiler available!")
  endif()
  enable_cxx11()
else()
  # set required standard to c++11
  set(CMAKE_CXX_STANDARD 11)
  set(CMAKE_CXX_STANDARD_REQUIRED ON)
endif ()

# Detect OpenMP support in a compiler. If the compiler supports OpenMP, flags
# to compile with OpenMP are returned and added for compilation.
if (USE_OPENMP)
  find_package(OpenMP)
endif ()

if (OPENMP_FOUND)
  set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} ${OpenMP_C_FLAGS}")
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${OpenMP_CXX_FLAGS}")
else ()
  # Disable warnings for all the unknown OpenMP pragmas.
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wno-unknown-pragmas")
endif ()

# The only dependency we need is Armadillo.
#
# We keep the minimum version in sync with mlpack, otherwise we could have
# irritating compatibility issues.
find_package(Armadillo 6.500.0 REQUIRED)
include_directories(BEFORE "${ARMADILLO_INCLUDE_DIR}")
include_directories(BEFORE "${CMAKE_SOURCE_DIR}/include/")

# Install the headers to the correct location.
install(DIRECTORY "${CMAKE_SOURCE_DIR}/include/ensmallen_bits"
        DESTINATION "${CMAKE_INSTALL_PREFIX}/include"
        PATTERN "*~" EXCLUDE
        PATTERN "*.sw*" EXCLUDE)
install(FILES ${CMAKE_SOURCE_DIR}/include/ensmallen.hpp
        DESTINATION "${CMAKE_INSTALL_PREFIX}/include")

enable_testing()

add_subdirectory(tests)

=== tests/CMakeLists.txt ===
project(ensmallen_tests CXX)

set(ENSMALLEN_TESTS_SOURCES
    main.cpp
    ada_delta_test.cpp
    ada_grad_test.cpp
    adam_test.cpp
    aug_lagrangian_test.cpp
    bigbatch_sgd_test.cpp
    cmaes_test.cpp
    cne_test.cpp
    eve_test.cpp
    frankwolfe_test.cpp
    function_test.cpp
    gradient_descent_test.cpp
    grid_search_test.cpp
    iqn_test.cpp
    katyusha_test.cpp
    lbfgs_test.cpp
    line_search_test.cpp
    lrsdp_test.cpp
    momentum_sgd_test.cpp
    nesterov_momentum_sgd_test.cpp
    parallel_sgd_test.cpp
    proximal_test.cpp
    rmsprop_test.cpp
    sa_test.cpp
    sarah_test.cpp
    scd_test.cpp
    sdp_primal_dual_test.cpp
    sgdr_test.cpp
    sgd_test.cpp
    smorms3_test.cpp
    snapshot_ensembles.cpp
    spalera_sgd_test.cpp
    spsa_test.cpp
    svrg_test.cpp
    swats_test.cpp
    wn_grad_test.cpp
)

set(CMAKE_RUNTIME_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR})
add_executable(${PROJECT_NAME} ${ENSMALLEN_TESTS_SOURCES})

target_link_libraries(${PROJECT_NAME} ${ARMADILLO_LIBRARIES})

# Copy test data into place.
add_custom_command(TARGET ${PROJECT_NAME}
  POST_BUILD
  COMMAND ${CMAKE_COMMAND} -E copy_directory ${CMAKE_CURRENT_SOURCE_DIR}/data/
      ${CMAKE_BINARY_DIR}/data/
)

enable_testing()
add_test(NAME ${PROJECT_NAME} COMMAND ${PROJECT_NAME}
    WORKING_DIRECTORY ${CMAKE_BINARY_DIR})

=== debian/changelog ===
ensmallen (1.14.3-1) unstable; urgency=medium

  * New upstream version

 -- Barak A. Pearlmutter <bap@debian.org>  Wed, 08 May 2019 22:01:31 +0100

ensmallen (1.14.2-1) unstable; urgency=medium

  * Initial debian release (closes: 928293)

 -- Barak A. Pearlmutter <bap@debian.org>  Wed, 01 May 2019 10:55:42 +0100

## ensmallen 1.15.1

=== CMakeLists.txt ===
--- 
+++ 
@@ -41,6 +41,13 @@
   set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wno-unknown-pragmas")
 endif ()
 
+# Set the CFLAGS and CXXFLAGS depending on the options the user specified.
+if(CMAKE_COMPILER_IS_GNUCC OR "${CMAKE_CXX_COMPILER_ID}" STREQUAL "Clang")
+
+  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wall -Wpedantic -Wunused-parameter")
+  set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wall -Wpedantic -Wunused-parameter")
+endif()
+
 # The only dependency we need is Armadillo.
 #
 # We keep the minimum version in sync with mlpack, otherwise we could have

=== tests/CMakeLists.txt ===
--- 
+++ 
@@ -23,6 +23,7 @@
     nesterov_momentum_sgd_test.cpp
     parallel_sgd_test.cpp
     proximal_test.cpp
+    quasi_hyperbolic_momentum_sgd_test.cpp
     rmsprop_test.cpp
     sa_test.cpp
     sarah_test.cpp

=== debian/changelog ===
ensmallen (1.15.1-1) unstable; urgency=medium

  * New upstream version

 -- Barak A. Pearlmutter <bap@debian.org>  Wed, 05 Jun 2019 20:44:09 +0100

ensmallen (1.15.0-2) unstable; urgency=medium

  * New upstream version

 -- Barak A. Pearlmutter <bap@debian.org>  Tue, 21 May 2019 09:42:07 +0100

=== debian/control ===
Source: ensmallen
Section: libs
Priority: optional
Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Barak A. Pearlmutter <bap@debian.org>
Build-Depends: debhelper-compat (= 12),
		cmake,
		libarmadillo-dev (>= 1:6.5), liblapack-dev
Standards-Version: 4.3.0
Homepage: https://www.ensmallen.org/
Vcs-Git: https://salsa.debian.org/science-team/ensmallen.git
Vcs-Browser: https://salsa.debian.org/science-team/ensmallen

Package: libensmallen-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: libarmadillo-dev (>= 1:6.5), liblapack-dev, ${misc:Depends}
Description: C++ header-only library for mathematical optimization
 Ensmallen provides a simple set of abstractions for writing an objective
 function to optimize. It also provides a large set of standard and cutting-edge
 optimizers that can be used for virtually any mathematical optimization task.
 These include full-batch gradient descent techniques, small-batch techniques,
 gradient-free optimizers, and constrained optimization.

=== debian/rules ===
#!/usr/bin/make -f

# export DH_VERBOSE=1

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

%:
	dh $@ ${DH_FLAGS}

## ensmallen 1.16.2

=== CMakeLists.txt ===


=== tests/CMakeLists.txt ===
--- 
+++ 
@@ -23,6 +23,7 @@
     nesterov_momentum_sgd_test.cpp
     parallel_sgd_test.cpp
     proximal_test.cpp
+    pso_test.cpp
     quasi_hyperbolic_momentum_sgd_test.cpp
     rmsprop_test.cpp
     sa_test.cpp
@@ -54,4 +55,4 @@
 
 enable_testing()
 add_test(NAME ${PROJECT_NAME} COMMAND ${PROJECT_NAME}
-    WORKING_DIRECTORY ${CMAKE_BINARY_DIR})
+WORKING_DIRECTORY ${CMAKE_BINARY_DIR})

=== debian/changelog ===
ensmallen (1.16.2-1) unstable; urgency=medium

  * New upstream version
  * Bump standards version

 -- Barak A. Pearlmutter <bap@debian.org>  Tue, 27 Aug 2019 10:04:37 +0100

=== debian/control ===
--- 
+++ 
@@ -6,7 +6,7 @@
 Build-Depends: debhelper-compat (= 12),
 		cmake,
 		libarmadillo-dev (>= 1:6.5), liblapack-dev
-Standards-Version: 4.3.0
+Standards-Version: 4.4.0
 Homepage: https://www.ensmallen.org/
 Vcs-Git: https://salsa.debian.org/science-team/ensmallen.git
 Vcs-Browser: https://salsa.debian.org/science-team/ensmallen

## ensmallen 2.11.3

=== CMakeLists.txt ===
# ensmallen CMake configuration.  This project has no configurable options---it
# just installs the headers to the install location, and optionally builds the
# test program.
cmake_minimum_required(VERSION 3.3.2)
project(ensmallen 
        LANGUAGES C CXX)

# Configurable options for CMake.
option(USE_OPENMP "If available, use OpenMP for parallelization." ON)
option(BUILD_TESTS "Build tests." ON)

set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} "${CMAKE_SOURCE_DIR}/CMake")

# Set required C++ standard to C++11.
set(CMAKE_CXX_STANDARD 11)
set(CMAKE_CXX_STANDARD_REQUIRED ON)

# Extract version from sources.
set(ENSMALLEN_VERSION_FILE_NAME "${PROJECT_SOURCE_DIR}/include/ensmallen_bits/ens_version.hpp")

if(NOT EXISTS ${ENSMALLEN_VERSION_FILE_NAME})
  message(FATAL_ERROR "Can't read ${ENSMALLEN_VERSION_FILE_NAME}")
endif()

file(READ ${ENSMALLEN_VERSION_FILE_NAME} ENSMALLEN_VERSION_FILE_CONTENTS)
string(REGEX REPLACE ".*#define ENS_VERSION_MAJOR ([0-9]+).*" "\\1" ENSMALLEN_VERSION_MAJOR "${ENSMALLEN_VERSION_FILE_CONTENTS}")
string(REGEX REPLACE ".*#define ENS_VERSION_MINOR ([0-9]+).*" "\\1" ENSMALLEN_VERSION_MINOR "${ENSMALLEN_VERSION_FILE_CONTENTS}")
string(REGEX REPLACE ".*#define ENS_VERSION_PATCH ([0-9]+).*" "\\1" ENSMALLEN_VERSION_PATCH "${ENSMALLEN_VERSION_FILE_CONTENTS}")

message(STATUS "Configuring ensmallen ${ENSMALLEN_VERSION_MAJOR}.${ENSMALLEN_VERSION_MINOR}.${ENSMALLEN_VERSION_PATCH}")
set(VERSION "${ENSMALLEN_VERSION_MAJOR}.${ENSMALLEN_VERSION_MINOR}.${ENSMALLEN_VERSION_PATCH}")

# Create library target.
add_library(ensmallen INTERFACE)
target_include_directories(ensmallen INTERFACE
  $<BUILD_INTERFACE:${PROJECT_SOURCE_DIR}/include>
  $<INSTALL_INTERFACE:include>)

# Set warning flags for target.
if(MSVC)
  target_compile_options(ensmallen INTERFACE /Wall )
else()
  target_compile_options(ensmallen INTERFACE -Wall -Wpedantic -Wunused-parameter)
endif()

# Find OpenMP and link it.
if(USE_OPENMP)
  if(NOT TARGET OpenMP::OpenMP_CXX)
    find_package(Threads REQUIRED)
    add_library(OpenMP::OpenMP_CXX IMPORTED INTERFACE)
    set_property(TARGET OpenMP::OpenMP_CXX
        PROPERTY INTERFACE_COMPILE_OPTIONS ${OpenMP_CXX_FLAGS})
    # Only works if the same flag is passed to the linker; use CMake 3.9+ otherwise (Intel, AppleClang).
    set_property(TARGET OpenMP::OpenMP_CXX
        PROPERTY INTERFACE_LINK_LIBRARIES ${OpenMP_CXX_FLAGS} Threads::Threads)
  endif()
  target_link_libraries(ensmallen INTERFACE OpenMP::OpenMP_CXX)
endif()

# Find Armadillo and link it.
find_package(Armadillo 8.400.0 REQUIRED)
target_link_libraries(ensmallen INTERFACE Armadillo::Armadillo)

# Set helper variables for creating the version, config and target files.
include(CMakePackageConfigHelpers)
set(ENSMALLEN_CMAKE_DIR "lib/cmake/ensmallen" CACHE STRING
      "Installation directory for cmake files, relative to ${CMAKE_INSTALL_PREFIX}.")
set(VERSION_CONFIG "${PROJECT_BINARY_DIR}/ensmallen-config-version.cmake")
set(PROJECT_CONFIG "${PROJECT_BINARY_DIR}/ensmallen-config.cmake")
set(TARGETS_EXPORT_NAME ensmallen-targets)

# Generate the version, config and target files into the build directory.
write_basic_package_version_file(${VERSION_CONFIG}
    VERSION ${VERSION}
    COMPATIBILITY AnyNewerVersion)
configure_package_config_file(${PROJECT_SOURCE_DIR}/CMake/ensmallen-config.cmake.in
    ${PROJECT_CONFIG}
    INSTALL_DESTINATION ${ENSMALLEN_CMAKE_DIR})
export(TARGETS ensmallen NAMESPACE ensmallen::
    FILE ${PROJECT_BINARY_DIR}/${TARGETS_EXPORT_NAME}.cmake)

# Install version, config and target files.
install(FILES ${PROJECT_CONFIG} ${VERSION_CONFIG}
    DESTINATION ${ENSMALLEN_CMAKE_DIR})
install(EXPORT ${TARGETS_EXPORT_NAME} DESTINATION ${ENSMALLEN_CMAKE_DIR}
    NAMESPACE ensmallen::)

# Export the targets and install the header files.
install(TARGETS ensmallen EXPORT ${TARGETS_EXPORT_NAME} DESTINATION lib)
install(DIRECTORY "${CMAKE_SOURCE_DIR}/include/ensmallen_bits"
        DESTINATION "${CMAKE_INSTALL_PREFIX}/include"
        PATTERN "*~" EXCLUDE
        PATTERN "*.sw*" EXCLUDE)
install(FILES ${CMAKE_SOURCE_DIR}/include/ensmallen.hpp
        DESTINATION "${CMAKE_INSTALL_PREFIX}/include")

# Enable testing and build tests.
enable_testing()
if (BUILD_TESTS)
  add_subdirectory(tests)
endif()

=== tests/CMakeLists.txt ===
--- 
+++ 
@@ -1,16 +1,19 @@
-project(ensmallen_tests CXX)
-
+# The tests that need to be compiled.
 set(ENSMALLEN_TESTS_SOURCES
     main.cpp
+    ada_bound_test.cpp
     ada_delta_test.cpp
     ada_grad_test.cpp
     adam_test.cpp
     aug_lagrangian_test.cpp
     bigbatch_sgd_test.cpp
+    callbacks_test.cpp
     cmaes_test.cpp
     cne_test.cpp
+    de_test.cpp
     eve_test.cpp
     frankwolfe_test.cpp
+    ftml_test.cpp
     function_test.cpp
     gradient_descent_test.cpp
     grid_search_test.cpp
@@ -18,6 +21,7 @@
     katyusha_test.cpp
     lbfgs_test.cpp
     line_search_test.cpp
+    lookahead_test.cpp
     lrsdp_test.cpp
     momentum_sgd_test.cpp
     nesterov_momentum_sgd_test.cpp
@@ -42,17 +46,16 @@
 )
 
 set(CMAKE_RUNTIME_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR})
-add_executable(${PROJECT_NAME} ${ENSMALLEN_TESTS_SOURCES})
-
-target_link_libraries(${PROJECT_NAME} ${ARMADILLO_LIBRARIES})
+add_executable(ensmallen_tests ${ENSMALLEN_TESTS_SOURCES})
+target_link_libraries(ensmallen_tests PRIVATE ensmallen)
 
 # Copy test data into place.
-add_custom_command(TARGET ${PROJECT_NAME}
+add_custom_command(TARGET ensmallen_tests
   POST_BUILD
   COMMAND ${CMAKE_COMMAND} -E copy_directory ${CMAKE_CURRENT_SOURCE_DIR}/data/
       ${CMAKE_BINARY_DIR}/data/
 )
 
 enable_testing()
-add_test(NAME ${PROJECT_NAME} COMMAND ${PROJECT_NAME}
+add_test(NAME ensmallen_tests COMMAND ensmallen_tests
 WORKING_DIRECTORY ${CMAKE_BINARY_DIR})

=== debian/changelog ===
ensmallen (2.11.3-1) unstable; urgency=medium

  * New upstream version
  * bump policy

 -- Barak A. Pearlmutter <bap@debian.org>  Fri, 21 Feb 2020 15:03:45 +0000

ensmallen (2.11.2-1) unstable; urgency=medium

  * New upstream version
  * Remove cherry-picked patches which are in this release

 -- Barak A. Pearlmutter <bap@debian.org>  Sun, 19 Jan 2020 09:01:18 +0000

ensmallen (2.11.1-5) unstable; urgency=medium

  * cherry-pick upstream patch for i386 issue

 -- Barak A. Pearlmutter <bap@debian.org>  Fri, 10 Jan 2020 12:04:07 +0000

ensmallen (2.11.1-4) unstable; urgency=medium

  * cherry-pick upstream patch for i386 issue

 -- Barak A. Pearlmutter <bap@debian.org>  Sat, 04 Jan 2020 20:05:43 +0000

ensmallen (2.11.1-3) unstable; urgency=medium

  * debian/rules: Oh where, oh where has my (testing) data gone?

 -- Barak A. Pearlmutter <bap@debian.org>  Fri, 03 Jan 2020 15:49:10 +0000

ensmallen (2.11.1-2) unstable; urgency=medium

  * Enable more verbose testing on the autobuilders

 -- Barak A. Pearlmutter <bap@debian.org>  Fri, 03 Jan 2020 14:03:30 +0000

ensmallen (2.11.1-1) unstable; urgency=medium

  * Remove upstreamed quilt patch
  * Remove unused variable from debian/rules
  * New upstream version

 -- Barak A. Pearlmutter <bap@debian.org>  Thu, 02 Jan 2020 08:13:46 +0000

ensmallen (2.10.4-2) unstable; urgency=medium

  * Patch for i386 build failure

 -- Barak A. Pearlmutter <bap@debian.org>  Thu, 05 Dec 2019 14:49:00 +0000

ensmallen (2.10.4-1) unstable; urgency=medium

  * New upstream version
  * Bump standards version

 -- Barak A. Pearlmutter <bap@debian.org>  Mon, 25 Nov 2019 15:37:41 +0000

ensmallen (2.10.3-1) unstable; urgency=medium

  * New upstream version

 -- Barak A. Pearlmutter <bap@debian.org>  Fri, 27 Sep 2019 09:00:43 +0100

ensmallen (2.10.2-1) unstable; urgency=medium

  * New upstream version

 -- Barak A. Pearlmutter <bap@debian.org>  Fri, 13 Sep 2019 12:37:41 +0100

ensmallen (2.10.0-1) unstable; urgency=medium

  * Switch gbp.conf to apparent new upstream tag format
  * New upstream version

 -- Barak A. Pearlmutter <bap@debian.org>  Mon, 09 Sep 2019 14:01:47 +0100

=== debian/control ===
--- 
+++ 
@@ -6,7 +6,8 @@
 Build-Depends: debhelper-compat (= 12),
 		cmake,
 		libarmadillo-dev (>= 1:6.5), liblapack-dev
-Standards-Version: 4.4.0
+Standards-Version: 4.5.0
+Rules-Requires-Root: no
 Homepage: https://www.ensmallen.org/
 Vcs-Git: https://salsa.debian.org/science-team/ensmallen.git
 Vcs-Browser: https://salsa.debian.org/science-team/ensmallen

=== debian/rules ===
#!/usr/bin/make -f

# export DH_VERBOSE=1

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

# Explicitly setting build directory because we need it to find the
# testing executable below, and there seems to be no robust way to
# figure out what it is if you don't set it explicitly! So we set it
# to what it would be anyway. Note: if we set it to the wrong thing it
# doesn't really matter anyway.  And if we just used dh_auto_test,
# we wouldn't need this because internally that command has access
# to the build directory.

BUILD_DIR := obj-$(shell dpkg-architecture --query DEB_BUILD_GNU_TYPE)

%:
	dh $@ --builddirectory=$(BUILD_DIR)

override_dh_auto_test:
ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
	@echo "This should give more useful/voluminous output, but could"
	@echo "also use the commented-out line below."
	cd $(BUILD_DIR) && ./ensmallen_tests --durations yes
	@echo "alternative: env CTEST_OUTPUT_ON_FAILURE=1 dh_auto_test"
endif

## ensmallen 2.14.1

=== debian/changelog ===
ensmallen (2.14.1-1) unstable; urgency=medium

  * New upstream version

 -- Barak A. Pearlmutter <bap@debian.org>  Thu, 27 Aug 2020 09:41:17 +0100

ensmallen (2.14.0-1) unstable; urgency=medium

  * New upstream version
  * Stop ignoring test failure (fixed upstream)

 -- Barak A. Pearlmutter <bap@debian.org>  Wed, 12 Aug 2020 22:28:05 +0100

ensmallen (2.13.0-1) unstable; urgency=medium

  * New upstream version

 -- Barak A. Pearlmutter <bap@debian.org>  Mon, 03 Aug 2020 23:32:41 +0100

ensmallen (2.12.1-1) unstable; urgency=medium

  * Set upstream metadata fields: Bug-Database, Bug-Submit, Repository,
    Repository-Browse.
  * New upstream version

 -- Barak A. Pearlmutter <bap@debian.org>  Wed, 22 Apr 2020 20:25:06 +0100

ensmallen (2.12.0-1) unstable; urgency=medium

  * New upstream version

 -- Barak A. Pearlmutter <bap@debian.org>  Mon, 06 Apr 2020 10:24:46 +0100

ensmallen (2.11.5-2) unstable; urgency=medium

  * Temporary fix: prevent test failure from blocking build on i386.
    See https://github.com/mlpack/ensmallen/issues/142

 -- Barak A. Pearlmutter <bap@debian.org>  Fri, 13 Mar 2020 10:13:18 +0000

ensmallen (2.11.5-1) unstable; urgency=medium

  * New upstream version

 -- Barak A. Pearlmutter <bap@debian.org>  Thu, 12 Mar 2020 15:22:34 +0000

=== debian/control ===
--- 
+++ 
@@ -1,9 +1,9 @@
 Source: ensmallen
 Section: libs
 Priority: optional
-Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
+Maintainer: Debian Science Maintainers <debian-science-maintainers@alioth-lists.debian.net>
 Uploaders: Barak A. Pearlmutter <bap@debian.org>
-Build-Depends: debhelper-compat (= 12),
+Build-Depends: debhelper-compat (= 13),
 		cmake,
 		libarmadillo-dev (>= 1:6.5), liblapack-dev
 Standards-Version: 4.5.0

=== debian/rules ===
#!/usr/bin/make -f

# export DH_VERBOSE=1

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

%:
	dh $@

override_dh_auto_test:
	env CTEST_OUTPUT_ON_FAILURE=1 dh_auto_test

## ensmallen 2.16.2

=== CMakeLists.txt ===
--- 
+++ 
@@ -38,9 +38,9 @@
 
 # Set warning flags for target.
 if(MSVC)
-  target_compile_options(ensmallen INTERFACE /Wall )
+  target_compile_options(ensmallen INTERFACE $<BUILD_INTERFACE:/Wall>)
 else()
-  target_compile_options(ensmallen INTERFACE -Wall -Wpedantic -Wunused-parameter)
+  target_compile_options(ensmallen INTERFACE $<BUILD_INTERFACE:-Wall -Wpedantic -Wunused-parameter>)
 endif()
 
 # Find OpenMP and link it.

=== tests/CMakeLists.txt ===
--- 
+++ 
@@ -25,6 +25,7 @@
     lrsdp_test.cpp
     momentum_sgd_test.cpp
     nesterov_momentum_sgd_test.cpp
+    nsga2_test.cpp
     parallel_sgd_test.cpp
     proximal_test.cpp
     pso_test.cpp

=== debian/changelog ===
ensmallen (2.16.2-2) unstable; urgency=medium

  * add autopkgtest support

 -- Barak A. Pearlmutter <bap@debian.org>  Fri, 16 Apr 2021 16:49:42 +0100

ensmallen (2.16.2-1) unstable; urgency=medium

  * New upstream version, WILL fix broken test (closes: #984868)

 -- Barak A. Pearlmutter <bap@debian.org>  Thu, 25 Mar 2021 21:55:13 +0000

ensmallen (2.16.1-2) unstable; urgency=medium

  * cherry pick quilt patch for debugging
    See https://github.com/mlpack/ensmallen/issues/253#issuecomment-792121815

 -- Barak A. Pearlmutter <bap@debian.org>  Sun, 07 Mar 2021 16:54:59 +0000

ensmallen (2.16.1-1) unstable; urgency=medium

  * New upstream version, may fix broken test (closes: #983169, #983941)
  * Bump policy
  * Remove multi-arch: same
    conflicts on /usr/lib/cmake/ensmallen/ensmallen-config-version.cmake on amd64, mips64el <-> i386, mipsel
    (alternative solution would be to put the file in
    /usr/lib/$(DEB_HOST_MULTIARCH)/cmake/... but that hardly seems worthwhile.)

 -- Barak A. Pearlmutter <bap@debian.org>  Fri, 05 Mar 2021 20:38:57 +0000

ensmallen (2.16.0-2) unstable; urgency=medium

  * Run test three times, per upstream request

 -- Barak A. Pearlmutter <bap@debian.org>  Thu, 04 Mar 2021 00:53:47 +0000

ensmallen (2.16.0-1) unstable; urgency=medium

  * New upstream version

 -- Barak A. Pearlmutter <bap@debian.org>  Fri, 19 Feb 2021 11:08:23 +0000

ensmallen (2.15.1-1) unstable; urgency=medium

  * New upstream version

 -- Barak A. Pearlmutter <bap@debian.org>  Mon, 09 Nov 2020 19:53:09 +0000

ensmallen (2.14.2-1) unstable; urgency=medium

  * New upstream version

 -- Barak A. Pearlmutter <bap@debian.org>  Tue, 08 Sep 2020 21:38:02 +0100

=== debian/control ===
--- 
+++ 
@@ -6,7 +6,7 @@
 Build-Depends: debhelper-compat (= 13),
 		cmake,
 		libarmadillo-dev (>= 1:6.5), liblapack-dev
-Standards-Version: 4.5.0
+Standards-Version: 4.5.1
 Rules-Requires-Root: no
 Homepage: https://www.ensmallen.org/
 Vcs-Git: https://salsa.debian.org/science-team/ensmallen.git
@@ -15,7 +15,6 @@
 Package: libensmallen-dev
 Section: libdevel
 Architecture: any
-Multi-Arch: same
 Depends: libarmadillo-dev (>= 1:6.5), liblapack-dev, ${misc:Depends}
 Description: C++ header-only library for mathematical optimization
  Ensmallen provides a simple set of abstractions for writing an objective

=== debian/rules ===
--- 
+++ 
@@ -7,5 +7,20 @@
 %:
 	dh $@
 
+# Number of times to run test suite.
+# (There was a heisenbug, and this was used to help track it down.)
+n_test = 1
+
 override_dh_auto_test:
-	env CTEST_OUTPUT_ON_FAILURE=1 dh_auto_test
+	ok=true; \
+	for i in $$(seq $(n_test)); do \
+	  echo "Test Run $$i"; \
+	  if env CTEST_OUTPUT_ON_FAILURE=1 dh_auto_test; \
+	  then \
+	    echo "success"; \
+	  else \
+	    echo "failure"; \
+	    ok=false; \
+	  fi; \
+	done; \
+	$${ok}

=== debian/tests/control ===
Tests: test-script
Depends: @, g++ | clang | c++-compiler, libarmadillo-dev
Restrictions: allow-stderr

## ensmallen 2.17.0

=== debian/changelog ===
ensmallen (2.17.0-2ubuntu1) impish; urgency=medium

  * Hardcode sigStackSize to 32768 to avoid FTBFS with glibc 2.34

 -- Graham Inggs <ginggs@ubuntu.com>  Tue, 31 Aug 2021 17:53:22 +0000

ensmallen (2.17.0-2) unstable; urgency=medium

  * bump policy
  * build ensmallen_tests in debian/rules (closes: #990927)

 -- Barak A. Pearlmutter <bap@debian.org>  Thu, 26 Aug 2021 11:49:10 +0100

ensmallen (2.17.0-1) unstable; urgency=medium

  * New upstream version

 -- Barak A. Pearlmutter <bap@debian.org>  Fri, 09 Jul 2021 12:44:38 +0100

=== debian/control ===
--- 
+++ 
@@ -1,12 +1,13 @@
 Source: ensmallen
 Section: libs
 Priority: optional
-Maintainer: Debian Science Maintainers <debian-science-maintainers@alioth-lists.debian.net>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Debian Science Maintainers <debian-science-maintainers@alioth-lists.debian.net>
 Uploaders: Barak A. Pearlmutter <bap@debian.org>
 Build-Depends: debhelper-compat (= 13),
 		cmake,
 		libarmadillo-dev (>= 1:6.5), liblapack-dev
-Standards-Version: 4.5.1
+Standards-Version: 4.6.0
 Rules-Requires-Root: no
 Homepage: https://www.ensmallen.org/
 Vcs-Git: https://salsa.debian.org/science-team/ensmallen.git

=== debian/rules ===
--- 
+++ 
@@ -6,6 +6,11 @@
 
 %:
 	dh $@
+
+# This really should be guarded depending on whether tests are going to be run.
+# Note that the build-time tests are pretty much redundant with autopkgtest.
+execute_after_dh_auto_build:
+	dh_auto_build -- ensmallen_tests
 
 # Number of times to run test suite.
 # (There was a heisenbug, and this was used to help track it down.)

=== debian/tests/control ===
Tests: test-script
Depends: @, g++ | clang | c++-compiler, libarmadillo-dev, pkg-config
Restrictions: allow-stderr

## ensmallen 2.18.1

=== debian/changelog ===
ensmallen (2.18.1-1) unstable; urgency=medium

  * New upstream version
    - fix which should solve armel arch test issue

 -- Barak A. Pearlmutter <bap@debian.org>  Mon, 22 Nov 2021 08:51:31 +0000

ensmallen (2.18.0-2) unstable; urgency=medium

  * Run test twice, and if either run fails run it another three times.

 -- Barak A. Pearlmutter <bap@debian.org>  Wed, 03 Nov 2021 12:28:40 +0000

ensmallen (2.18.0-1) unstable; urgency=medium

  * New upstream version
  * Reformat debian/patch/0002-... for consistency

 -- Barak A. Pearlmutter <bap@debian.org>  Tue, 26 Oct 2021 12:06:19 +0100

ensmallen (2.17.0-3) unstable; urgency=medium

  * Team upload.
  * d/rules: ensmallen_tests is no longer built if tests are not going to run.
  * d/t/test-script: build i386 tests with -ffloat-store, this fixes
    autopkgtest failure on that architecture.  (Closes: #993043)
  * d/{,t/}control, 0002-use-system-catch.patch: use the operating system's
    catch2 header, instead of the vendored one.  (Closes: #993513)

 -- Étienne Mollier <emollier@debian.org>  Sun, 19 Sep 2021 16:15:17 +0200

=== debian/rules ===
#!/usr/bin/make -f

# export DH_VERBOSE=1

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

%:
	dh $@

# Note that the build-time tests are pretty much redundant with autopkgtest.
ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
execute_after_dh_auto_build:
	dh_auto_build -- ensmallen_tests
endif

# There was a heisenbug, and this was used to help track it down.
# Number of times to run test suite.
n_test = 2
# Number of times to rerun test suite assuming it failed one of the first $(n_test) runs.
n_retest = 3
override_dh_auto_test:
	ok=true; \
	for i in $$(seq $(n_test)); do \
	  echo "Test Run $$i"; \
	  if env CTEST_OUTPUT_ON_FAILURE=1 dh_auto_test; then \
	    echo "success"; \
	  else \
	    echo "failure"; \
	    ok=false; \
	  fi; \
	done; \
	if $${ok}; then \
	  echo "All $(n_test) test runs succeeded."; \
	else \
	  for i in $$(seq $(n_retest)); do \
	    echo "Test Rerun $$i"; \
	    if env CTEST_OUTPUT_ON_FAILURE=1 dh_auto_test; then \
	      echo "success"; \
	    else \
	      echo "failure"; \
	    fi; \
	  done; \
	fi; \
	$${ok}

## ensmallen 2.18.2

=== tests/CMakeLists.txt ===
--- 
+++ 
@@ -23,6 +23,7 @@
     line_search_test.cpp
     lookahead_test.cpp
     lrsdp_test.cpp
+    moead_test.cpp
     momentum_sgd_test.cpp
     nesterov_momentum_sgd_test.cpp
     nsga2_test.cpp
@@ -47,7 +48,7 @@
 )
 
 set(CMAKE_RUNTIME_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR})
-add_executable(ensmallen_tests ${ENSMALLEN_TESTS_SOURCES})
+add_executable(ensmallen_tests EXCLUDE_FROM_ALL ${ENSMALLEN_TESTS_SOURCES})
 target_link_libraries(ensmallen_tests PRIVATE ensmallen)
 
 # Copy test data into place.

=== debian/changelog ===
ensmallen (2.18.2-1) unstable; urgency=medium

  * New upstream version
  * Configure to use OpenMP
  * Stray vendored catch

 -- Barak A. Pearlmutter <bap@debian.org>  Fri, 18 Feb 2022 10:17:34 +0000

=== debian/control ===
--- 
+++ 
@@ -1,10 +1,10 @@
 Source: ensmallen
 Section: libs
 Priority: optional
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Debian Science Maintainers <debian-science-maintainers@alioth-lists.debian.net>
+Maintainer: Debian Science Maintainers <debian-science-maintainers@alioth-lists.debian.net>
 Uploaders: Barak A. Pearlmutter <bap@debian.org>
 Build-Depends: debhelper-compat (= 13),
+		catch2,
 		cmake,
 		libarmadillo-dev (>= 1:6.5), liblapack-dev
 Standards-Version: 4.6.0

## ensmallen 2.19.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -2,12 +2,11 @@
 # just installs the headers to the install location, and optionally builds the
 # test program.
 cmake_minimum_required(VERSION 3.3.2)
-project(ensmallen 
+project(ensmallen
         LANGUAGES C CXX)
 
 # Configurable options for CMake.
 option(USE_OPENMP "If available, use OpenMP for parallelization." ON)
-option(BUILD_TESTS "Build tests." ON)
 
 set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} "${CMAKE_SOURCE_DIR}/CMake")
 
@@ -58,7 +57,7 @@
 endif()
 
 # Find Armadillo and link it.
-find_package(Armadillo 8.400.0 REQUIRED)
+find_package(Armadillo 9.800.0 REQUIRED)
 target_link_libraries(ensmallen INTERFACE Armadillo::Armadillo)
 
 # Set helper variables for creating the version, config and target files.
@@ -96,6 +95,4 @@
 
 # Enable testing and build tests.
 enable_testing()
-if (BUILD_TESTS)
-  add_subdirectory(tests)
-endif()
+add_subdirectory(tests)

## ensmallen 2.19.1

=== debian/changelog ===
ensmallen (2.19.1-2) unstable; urgency=medium

  * Merge upstream commit for 2.19.1 update straggler
  * Patch to relax test margin for i386 failure (closes: #1010431)

 -- Barak A. Pearlmutter <bap@debian.org>  Tue, 21 Feb 2023 10:54:09 +0000

ensmallen (2.19.1-1) unstable; urgency=medium

  * Janitor yak shave build dependency versions
  * New upstream version
  * Update standards version to 4.6.2, no changes needed.
  * Forward port quilt patches

 -- Barak A. Pearlmutter <bap@debian.org>  Sun, 19 Feb 2023 23:06:57 +0000

ensmallen (2.19.0-1) unstable; urgency=medium

  * New upstream version

 -- Barak A. Pearlmutter <bap@debian.org>  Sun, 24 Apr 2022 11:32:41 +0100

=== debian/control ===
--- 
+++ 
@@ -6,8 +6,8 @@
 Build-Depends: debhelper-compat (= 13),
 		catch2,
 		cmake,
-		libarmadillo-dev (>= 1:6.5), liblapack-dev
-Standards-Version: 4.6.0
+		libarmadillo-dev, liblapack-dev
+Standards-Version: 4.6.2
 Rules-Requires-Root: no
 Homepage: https://www.ensmallen.org/
 Vcs-Git: https://salsa.debian.org/science-team/ensmallen.git
@@ -16,7 +16,7 @@
 Package: libensmallen-dev
 Section: libdevel
 Architecture: any
-Depends: libarmadillo-dev (>= 1:6.5), liblapack-dev, ${misc:Depends}
+Depends: libarmadillo-dev, liblapack-dev, ${misc:Depends}
 Description: C++ header-only library for mathematical optimization
  Ensmallen provides a simple set of abstractions for writing an objective
  function to optimize. It also provides a large set of standard and cutting-edge

## ensmallen 2.20.0

=== debian/changelog ===
ensmallen (2.20.0-1) unstable; urgency=medium

  * New upstream version
  * Forward port quilt patches

 -- Barak A. Pearlmutter <bap@debian.org>  Sun, 08 Oct 2023 11:31:55 +0100

## ensmallen 2.21.0

=== debian/changelog ===
ensmallen (2.21.0-1) unstable; urgency=medium

  * New upstream version

 -- Barak A. Pearlmutter <bap@debian.org>  Fri, 01 Dec 2023 11:53:31 +0000

ensmallen (2.20.0-2) unstable; urgency=medium

  * Team upload
  * Use vendored catch2 again (Closes: #1054712)

 -- Bastian Germann <bage@debian.org>  Thu, 02 Nov 2023 00:23:12 +0100

## ensmallen 2.21.1

=== CMakeLists.txt ===
--- 
+++ 
@@ -2,6 +2,9 @@
 # just installs the headers to the install location, and optionally builds the
 # test program.
 cmake_minimum_required(VERSION 3.3.2)
+if (NOT CMAKE_BUILD_TYPE)
+  set(CMAKE_BUILD_TYPE "Release")  # ensure the tests are built with optimisation
+endif ()
 project(ensmallen
         LANGUAGES C CXX)

=== tests/CMakeLists.txt ===
--- 
+++ 
@@ -1,16 +1,22 @@
 # The tests that need to be compiled.
 set(ENSMALLEN_TESTS_SOURCES
     main.cpp
+    active_cmaes_test.cpp
+    ada_belief_test.cpp
     ada_bound_test.cpp
     ada_delta_test.cpp
     ada_grad_test.cpp
+    ada_sqrt_test.cpp
     adam_test.cpp
     aug_lagrangian_test.cpp
     bigbatch_sgd_test.cpp
     callbacks_test.cpp
+    cd_test.cpp
     cmaes_test.cpp
     cne_test.cpp
     de_test.cpp
+    demon_adam_test.cpp
+    demon_sgd_test.cpp
     eve_test.cpp
     frankwolfe_test.cpp
     ftml_test.cpp
@@ -34,7 +40,6 @@
     rmsprop_test.cpp
     sa_test.cpp
     sarah_test.cpp
-    scd_test.cpp
     sdp_primal_dual_test.cpp
     sgdr_test.cpp
     sgd_test.cpp
@@ -45,6 +50,7 @@
     svrg_test.cpp
     swats_test.cpp
     wn_grad_test.cpp
+    yogi_test.cpp
 )
 
 set(CMAKE_RUNTIME_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR})

=== debian/changelog ===
ensmallen (2.21.1-1) unstable; urgency=medium

  * Merge upstream commit to finish updating the version
  * New upstream version

 -- Barak A. Pearlmutter <bap@debian.org>  Thu, 22 Feb 2024 12:04:06 +0000

=== debian/control ===
--- 
+++ 
@@ -4,7 +4,6 @@
 Maintainer: Debian Science Maintainers <debian-science-maintainers@alioth-lists.debian.net>
 Uploaders: Barak A. Pearlmutter <bap@debian.org>
 Build-Depends: debhelper-compat (= 13),
-		catch2,
 		cmake,
 		libarmadillo-dev, liblapack-dev
 Standards-Version: 4.6.2

## ensmallen 2.22.1

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,7 +1,7 @@
 # ensmallen CMake configuration.  This project has no configurable options---it
 # just installs the headers to the install location, and optionally builds the
 # test program.
-cmake_minimum_required(VERSION 3.3.2)
+cmake_minimum_required(VERSION 3.3.2...3.5)
 if (NOT CMAKE_BUILD_TYPE)
   set(CMAKE_BUILD_TYPE "Release")  # ensure the tests are built with optimisation
 endif ()
@@ -13,8 +13,8 @@
 
 set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} "${CMAKE_SOURCE_DIR}/CMake")
 
-# Set required C++ standard to C++11.
-set(CMAKE_CXX_STANDARD 11)
+# Set required C++ standard to C++14.
+set(CMAKE_CXX_STANDARD 14)
 set(CMAKE_CXX_STANDARD_REQUIRED ON)
 
 # Extract version from sources.
@@ -42,7 +42,7 @@
 if(MSVC)
   target_compile_options(ensmallen INTERFACE $<BUILD_INTERFACE:/Wall>)
 else()
-  target_compile_options(ensmallen INTERFACE $<BUILD_INTERFACE:-Wall -Wpedantic -Wunused-parameter>)
+  target_compile_options(ensmallen INTERFACE $<BUILD_INTERFACE:-Wall -Wpedantic -Wunused>)
 endif()
 
 # Find OpenMP and link it.
@@ -60,7 +60,7 @@
 endif()
 
 # Find Armadillo and link it.
-find_package(Armadillo 9.800.0 REQUIRED)
+find_package(Armadillo 10.8.2 REQUIRED)
 target_link_libraries(ensmallen INTERFACE Armadillo::Armadillo)
 
 # Set helper variables for creating the version, config and target files.

=== debian/changelog ===
ensmallen (2.22.1-2) unstable; urgency=medium

  * Cherry-pick two upstream commits
    - the upstreamed version of the include file quilt patch
    - tollerance reduction on test case that failed on 32-bit architectures

 -- Barak A. Pearlmutter <bap@debian.org>  Wed, 26 Feb 2025 19:47:05 +0000

ensmallen (2.22.1-1) unstable; urgency=medium

  * New usptream version
  * Bump policy

 -- Barak A. Pearlmutter <bap@debian.org>  Wed, 04 Dec 2024 20:38:28 +0000

=== debian/control ===
--- 
+++ 
@@ -6,7 +6,7 @@
 Build-Depends: debhelper-compat (= 13),
 		cmake,
 		libarmadillo-dev, liblapack-dev
-Standards-Version: 4.6.2
+Standards-Version: 4.7.0
 Rules-Requires-Root: no
 Homepage: https://www.ensmallen.org/
 Vcs-Git: https://salsa.debian.org/science-team/ensmallen.git

## ensmallen 2.22.2

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,7 +1,7 @@
 # ensmallen CMake configuration.  This project has no configurable options---it
 # just installs the headers to the install location, and optionally builds the
 # test program.
-cmake_minimum_required(VERSION 3.3.2...3.5)
+cmake_minimum_required(VERSION 3.5...4.0)
 if (NOT CMAKE_BUILD_TYPE)
   set(CMAKE_BUILD_TYPE "Release")  # ensure the tests are built with optimisation
 endif ()

=== tests/CMakeLists.txt ===
--- 
+++ 
@@ -24,16 +24,19 @@
     gradient_descent_test.cpp
     grid_search_test.cpp
     iqn_test.cpp
+    indicators_test.cpp
     katyusha_test.cpp
     lbfgs_test.cpp
     line_search_test.cpp
     lookahead_test.cpp
     lrsdp_test.cpp
     moead_test.cpp
+    agemoea_test.cpp
     momentum_sgd_test.cpp
     nesterov_momentum_sgd_test.cpp
     nsga2_test.cpp
     parallel_sgd_test.cpp
+    pop_cmaes_test.cpp
     proximal_test.cpp
     pso_test.cpp
     quasi_hyperbolic_momentum_sgd_test.cpp

=== debian/changelog ===
ensmallen (2.22.2-1) unstable; urgency=medium

  * New upstream version
  * Update packaging scripts

 -- Barak A. Pearlmutter <bap@debian.org>  Thu, 14 Aug 2025 01:58:35 +0100

=== debian/control ===
--- 
+++ 
@@ -6,8 +6,7 @@
 Build-Depends: debhelper-compat (= 13),
 		cmake,
 		libarmadillo-dev, liblapack-dev
-Standards-Version: 4.7.0
-Rules-Requires-Root: no
+Standards-Version: 4.7.2
 Homepage: https://www.ensmallen.org/
 Vcs-Git: https://salsa.debian.org/science-team/ensmallen.git
 Vcs-Browser: https://salsa.debian.org/science-team/ensmallen

## ensmallen 3.10.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -10,12 +10,17 @@
 
 # Configurable options for CMake.
 option(USE_OPENMP "If available, use OpenMP for parallelization." ON)
+option(USE_BANDICOOT "If available, build against Bandicoot for GPU support." ON)
 
 set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} "${CMAKE_SOURCE_DIR}/CMake")
 
-# Set required C++ standard to C++14.
-set(CMAKE_CXX_STANDARD 14)
-set(CMAKE_CXX_STANDARD_REQUIRED ON)
+# Set minimum required C++ standard to C++14.
+if (NOT CMAKE_CXX_STANDARD)
+  set(CMAKE_CXX_STANDARD 14)
+  set(CMAKE_CXX_STANDARD_REQUIRED ON)
+elseif (${CMAKE_CXX_STANDARD} LESS 14)
+  message(FATAL_ERROR "ensmallen requires C++14 or newer!")
+endif ()
 
 # Extract version from sources.
 set(ENSMALLEN_VERSION_FILE_NAME "${PROJECT_SOURCE_DIR}/include/ensmallen_bits/ens_version.hpp")
@@ -59,6 +64,17 @@
   target_link_libraries(ensmallen INTERFACE OpenMP::OpenMP_CXX)
 endif()
 
+if(USE_BANDICOOT)
+  # Find Bandicoot and link it.
+  find_package(Bandicoot 2.1.0)
+  if(BANDICOOT_FOUND)
+    target_link_libraries(ensmallen INTERFACE Bandicoot::Bandicoot)
+    target_include_directories(ensmallen INTERFACE ${BANDICOOT_INCLUDE_DIR})
+
+    add_definitions(-DENS_USE_COOT)
+  endif()
+endif()
+
 # Find Armadillo and link it.
 find_package(Armadillo 10.8.2 REQUIRED)
 target_link_libraries(ensmallen INTERFACE Armadillo::Armadillo)

=== tests/CMakeLists.txt ===
--- 
+++ 
@@ -18,6 +18,9 @@
     demon_adam_test.cpp
     demon_sgd_test.cpp
     eve_test.cpp
+    fasta_test.cpp
+    fbs_test.cpp
+    fista_test.cpp
     frankwolfe_test.cpp
     ftml_test.cpp
     function_test.cpp
@@ -52,6 +55,7 @@
     spsa_test.cpp
     svrg_test.cpp
     swats_test.cpp
+    test_types.cpp
     wn_grad_test.cpp
     yogi_test.cpp
 )

=== debian/changelog ===
ensmallen (3.10.0-1) unstable; urgency=medium

  * New upstream version

 -- Barak A. Pearlmutter <bap@debian.org>  Tue, 14 Oct 2025 15:26:12 +0100

=== debian/rules ===
--- 
+++ 
@@ -6,6 +6,9 @@
 
 %:
 	dh $@
+
+override_dh_auto_configure:
+	dh_auto_configure -- -DUSE_OPENMP=ON
 
 # Note that the build-time tests are pretty much redundant with autopkgtest.
 ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))

=== debian/tests/control ===
Tests: test-script
Depends: @, g++ | clang | c++-compiler, libarmadillo-dev, pkg-config, catch2
Restrictions: allow-stderr

=== debian/watch ===
version=4
https://www.ensmallen.org/files/@PACKAGE@-@ANY_VERSION@@ARCHIVE_EXT@

## ensmallen 3.11.0

=== tests/CMakeLists.txt ===
--- 
+++ 
@@ -15,6 +15,7 @@
     cmaes_test.cpp
     cne_test.cpp
     de_test.cpp
+    delta_bar_delta_test.cpp
     demon_adam_test.cpp
     demon_sgd_test.cpp
     eve_test.cpp
@@ -35,6 +36,7 @@
     lrsdp_test.cpp
     moead_test.cpp
     agemoea_test.cpp
+    momentum_delta_bar_delta_test.cpp
     momentum_sgd_test.cpp
     nesterov_momentum_sgd_test.cpp
     nsga2_test.cpp

=== debian/changelog ===
ensmallen (3.11.0-1) unstable; urgency=medium

  * Update maintainer email in control file
  * Update debian/watch to Version: 5
  * New upstream version

 -- Barak A. Pearlmutter <bap@debian.org>  Thu, 01 Jan 2026 22:39:36 +0000

=== debian/control ===
--- 
+++ 
@@ -1,7 +1,7 @@
 Source: ensmallen
 Section: libs
 Priority: optional
-Maintainer: Debian Science Maintainers <debian-science-maintainers@alioth-lists.debian.net>
+Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
 Uploaders: Barak A. Pearlmutter <bap@debian.org>
 Build-Depends: debhelper-compat (= 13),
 		cmake,

=== debian/watch ===
Version: 5
Source: https://www.ensmallen.org/files/
Matching-Pattern: @PACKAGE@-@ANY_VERSION@@ARCHIVE_EXT@
